diff --git a/src/charts/legend/legendlayout2_p.h b/src/charts/legend/legendlayout2_p.h
index a06ef9c3..8c876b3c 100644
--- a/src/charts/legend/legendlayout2_p.h
+++ b/src/charts/legend/legendlayout2_p.h
@@ -41,13 +41,14 @@
 #include <QtWidgets/QGraphicsLayout>
 #include <QtCharts/QChartGlobal>
 #include <QtCharts/private/qchartglobal_p.h>
+#include <QQuickItem>
 
 QT_CHARTS_BEGIN_NAMESPACE
 
 class QLegend2;
 class LegendMarkerItem;
 
-class QT_CHARTS_PRIVATE_EXPORT LegendLayout2 : public QGraphicsLayout
+class QT_CHARTS_PRIVATE_EXPORT LegendLayout2 : public QQuickItem
 {
 public:
 
diff --git a/src/charts/legend/legendscroller2.cpp b/src/charts/legend/legendscroller2.cpp
index 5a3805cb..aad07e36 100644
--- a/src/charts/legend/legendscroller2.cpp
+++ b/src/charts/legend/legendscroller2.cpp
@@ -66,14 +66,14 @@ void LegendScroller2::mouseReleaseEvent(QGraphicsSceneMouseEvent *event)
     Scroller::handleMouseReleaseEvent(event);
 
     if (!event->isAccepted()) {
-        QList<QGraphicsItem *> items = scene()->items(event->scenePos());
+//        QList<QQuickItem *> items = scene()->items(event->scenePos());
 
-        foreach (QGraphicsItem *i, items) {
-            if (d_ptr->m_markerHash.contains(i)) {
-                QLegendMarker *marker = d_ptr->m_markerHash.value(i);
-                emit marker->clicked();
-            }
-        }
+//        foreach (QQuickItem *i, items) {
+//            if (d_ptr->m_markerHash.contains(i)) {
+//                QLegendMarker *marker = d_ptr->m_markerHash.value(i);
+//                emit marker->clicked();
+//            }
+//        }
     event->accept();
     }
 }
diff --git a/src/charts/legend/qlegend2.cpp b/src/charts/legend/qlegend2.cpp
index 889f467e..39621e80 100644
--- a/src/charts/legend/qlegend2.cpp
+++ b/src/charts/legend/qlegend2.cpp
@@ -41,7 +41,6 @@
 #include <private/chartdataset_p.h>
 #include <QtGui/QPainter>
 #include <QtGui/QPen>
-#include <QtWidgets/QGraphicsItemGroup>
 
 QT_CHARTS_BEGIN_NAMESPACE
 
@@ -257,14 +256,14 @@ QT_CHARTS_BEGIN_NAMESPACE
     This signal is emitted when the visibility of tooltips is changed to \a showToolTips.
 */
 
-QLegend2::QLegend2(QChart2 *chart): QGraphicsWidget(chart),
+QLegend2::QLegend2(QChart2 *chart): QQuickItem(chart),
     d_ptr(new QLegendPrivate2(chart->d_ptr->m_presenter, chart, this))
 {
-    setZValue(ChartPresenter2::LegendZValue);
-    setFlags(QGraphicsItem::ItemClipsChildrenToShape);
+//    setZValue(ChartPresenter2::LegendZValue);
+    setFlags(QQuickItem::ItemClipsChildrenToShape);
     QObject::connect(chart->d_ptr->m_dataset, SIGNAL(seriesAdded(QAbstractSeries*)), d_ptr.data(), SLOT(handleSeriesAdded(QAbstractSeries*)));
     QObject::connect(chart->d_ptr->m_dataset, SIGNAL(seriesRemoved(QAbstractSeries*)), d_ptr.data(), SLOT(handleSeriesRemoved(QAbstractSeries*)));
-    setLayout(d_ptr->m_layout);
+//    setLayout(d_ptr->m_layout);
 }
 
 /*!
@@ -289,7 +288,9 @@ void QLegend2::paint(QPainter *painter, const QStyleOptionGraphicsItem *option,
     painter->setOpacity(opacity());
     painter->setPen(d_ptr->m_pen);
     painter->setBrush(d_ptr->m_brush);
-    painter->drawRoundRect(rect(), d_ptr->roundness(rect().width()), d_ptr->roundness(rect().height()));
+
+    // TODO!!!!!
+//    painter->drawRoundRect(rect(), d_ptr->roundness(rect().width()), d_ptr->roundness(rect().height()));
 }
 
 
@@ -357,16 +358,16 @@ QPen QLegend2::pen() const
 
 void QLegend2::setFont(const QFont &font)
 {
-    if (d_ptr->m_font != font) {
-        // Hide items to avoid flickering
-        d_ptr->items()->setVisible(false);
-        d_ptr->m_font = font;
-        foreach (QLegendMarker *marker, d_ptr->markers()) {
-            marker->setFont(d_ptr->m_font);
-        }
-        layout()->invalidate();
-        emit fontChanged(font);
-    }
+//    if (d_ptr->m_font != font) {
+//        // Hide items to avoid flickering
+//        d_ptr->items()->setVisible(false);
+//        d_ptr->m_font = font;
+//        foreach (QLegendMarker *marker, d_ptr->markers()) {
+//            marker->setFont(d_ptr->m_font);
+//        }
+//        layout()->invalidate();
+//        emit fontChanged(font);
+//    }
 }
 
 QFont QLegend2::font() const
@@ -434,10 +435,10 @@ QColor QLegend2::labelColor() const
 
 void QLegend2::setAlignment(Qt::Alignment alignment)
 {
-    if (d_ptr->m_alignment != alignment) {
-        d_ptr->m_alignment = alignment;
-        layout()->invalidate();
-    }
+//    if (d_ptr->m_alignment != alignment) {
+//        d_ptr->m_alignment = alignment;
+//        layout()->invalidate();
+//    }
 }
 
 Qt::Alignment QLegend2::alignment() const
@@ -450,10 +451,10 @@ Qt::Alignment QLegend2::alignment() const
  */
 void QLegend2::detachFromChart()
 {
-    d_ptr->m_attachedToChart = false;
-//    layout()->invalidate();
-    d_ptr->m_chart->layout()->invalidate();
-    setParent(0);
+//    d_ptr->m_attachedToChart = false;
+////    layout()->invalidate();
+//    d_ptr->m_chart->layout()->invalidate();
+//    setParent(0);
 
 }
 
@@ -462,10 +463,10 @@ void QLegend2::detachFromChart()
  */
 void QLegend2::attachToChart()
 {
-    d_ptr->m_attachedToChart = true;
-//    layout()->invalidate();
-    d_ptr->m_chart->layout()->invalidate();
-    setParent(d_ptr->m_chart);
+//    d_ptr->m_attachedToChart = true;
+////    layout()->invalidate();
+//    d_ptr->m_chart->layout()->invalidate();
+//    setParent(d_ptr->m_chart);
 }
 
 /*!
@@ -512,11 +513,11 @@ bool QLegend2::reverseMarkers()
 
 void QLegend2::setReverseMarkers(bool reverseMarkers)
 {
-    if (d_ptr->m_reverseMarkers != reverseMarkers) {
-        d_ptr->m_reverseMarkers = reverseMarkers;
-        layout()->invalidate();
-        emit reverseMarkersChanged(reverseMarkers);
-    }
+//    if (d_ptr->m_reverseMarkers != reverseMarkers) {
+//        d_ptr->m_reverseMarkers = reverseMarkers;
+//        layout()->invalidate();
+//        emit reverseMarkersChanged(reverseMarkers);
+//    }
 }
 
 /*!
@@ -551,14 +552,14 @@ QLegend::MarkerShape QLegend2::markerShape() const
 
 void QLegend2::setMarkerShape(QLegend::MarkerShape shape)
 {
-    QLegend::MarkerShape newShape = shape;
-    if (newShape == QLegend::MarkerShapeDefault)
-        newShape = QLegend::MarkerShapeRectangle;
-    if (d_ptr->m_markerShape != newShape) {
-        d_ptr->m_markerShape = newShape;
-        layout()->invalidate();
-        emit markerShapeChanged(newShape);
-    }
+//    QLegend::MarkerShape newShape = shape;
+//    if (newShape == QLegend::MarkerShapeDefault)
+//        newShape = QLegend::MarkerShapeRectangle;
+//    if (d_ptr->m_markerShape != newShape) {
+//        d_ptr->m_markerShape = newShape;
+//        layout()->invalidate();
+//        emit markerShapeChanged(newShape);
+//    }
 }
 
 /*!
@@ -567,9 +568,9 @@ void QLegend2::setMarkerShape(QLegend::MarkerShape shape)
  */
 void QLegend2::hideEvent(QHideEvent *event)
 {
-    if (isAttachedToChart())
-        d_ptr->m_presenter->layout()->invalidate();
-    QGraphicsWidget::hideEvent(event);
+//    if (isAttachedToChart())
+//        d_ptr->m_presenter->layout()->invalidate();
+//    QGraphicsWidget::hideEvent(event);
 }
 /*!
     \internal
@@ -577,10 +578,10 @@ void QLegend2::hideEvent(QHideEvent *event)
  */
 void QLegend2::showEvent(QShowEvent *event)
 {
-    if (isAttachedToChart())
-        layout()->invalidate();
-    QGraphicsWidget::showEvent(event);
-    //layout activation will show the items
+//    if (isAttachedToChart())
+//        layout()->invalidate();
+//    QGraphicsWidget::showEvent(event);
+//    //layout activation will show the items
 }
 
 ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
@@ -590,7 +591,7 @@ QLegendPrivate2::QLegendPrivate2(ChartPresenter2 *presenter, QChart2 *chart, QLe
       m_presenter(presenter),
       m_layout(new LegendLayout2(q)),
       m_chart(chart),
-      m_items(new QGraphicsItemGroup(q)),
+//      m_items(new QQuickItemGroup(q)),
       m_alignment(Qt::AlignTop),
       m_brush(QChartPrivate2::defaultBrush()),
       m_pen(QChartPrivate2::defaultPen()),
@@ -602,7 +603,7 @@ QLegendPrivate2::QLegendPrivate2(ChartPresenter2 *presenter, QChart2 *chart, QLe
       m_showToolTips(false),
       m_markerShape(QLegend::MarkerShapeRectangle)
 {
-    m_items->setHandlesChildEvents(false);
+//    m_items->setHandlesChildEvents(false);
 }
 
 QLegendPrivate2::~QLegendPrivate2()
@@ -667,7 +668,7 @@ void QLegendPrivate2::handleSeriesAdded(QAbstractSeries *series)
     QObject::connect(series, SIGNAL(visibleChanged()), this, SLOT(handleSeriesVisibleChanged()));
 
     m_series.append(series);
-    m_items->setVisible(false);
+//    m_items->setVisible(false);
     m_layout->invalidate();
 }
 
@@ -778,15 +779,15 @@ void QLegendPrivate2::handleCountChanged()
             m_markers.insert(pos, createdMarkers.at(c));
     }
 
-    q_ptr->layout()->invalidate();
+//    q_ptr->layout()->invalidate();
 }
 
 // Helper function for marker insertion except m_markers handling
 void QLegendPrivate2::insertMarkerHelper(QLegendMarker *marker)
 {
     LegendMarkerItem *item = marker->d_ptr->item();
-    m_items->addToGroup(item);
-    m_markerHash.insert(item, marker);
+//    m_items->addToGroup(item);
+//    m_markerHash.insert(item, marker);
 }
 
 void QLegendPrivate2::addMarkers(QList<QLegendMarker *> markers)
@@ -800,11 +801,11 @@ void QLegendPrivate2::addMarkers(QList<QLegendMarker *> markers)
 // Helper function for marker removal except m_markers handling
 void QLegendPrivate2::removeMarkerHelper(QLegendMarker *marker)
 {
-    LegendMarkerItem *item = marker->d_ptr->item();
-    item->setVisible(false);
-    m_items->removeFromGroup(item);
-    m_markerHash.remove(item);
-    delete marker;
+//    LegendMarkerItem *item = marker->d_ptr->item();
+//    item->setVisible(false);
+//    m_items->removeFromGroup(item);
+//    m_markerHash.remove(item);
+//    delete marker;
 }
 
 void QLegendPrivate2::removeMarkers(QList<QLegendMarker *> markers)
diff --git a/src/charts/legend/qlegend2.h b/src/charts/legend/qlegend2.h
index 29c669a6..20c02858 100644
--- a/src/charts/legend/qlegend2.h
+++ b/src/charts/legend/qlegend2.h
@@ -35,6 +35,7 @@
 #include <QtGui/QPen>
 #include <QtGui/QBrush>
 #include <QLegend>
+#include <QQuickItem>
 
 QT_CHARTS_BEGIN_NAMESPACE
 
@@ -43,7 +44,7 @@ class QLegendPrivate2;
 class QLegendMarker;
 class QAbstractSeries;
 
-class QT_CHARTS_EXPORT QLegend2 : public QGraphicsWidget
+class QT_CHARTS_EXPORT QLegend2 : public QQuickItem
 {
     Q_OBJECT
     Q_PROPERTY(Qt::Alignment alignment READ alignment WRITE setAlignment)
diff --git a/src/charts/legend/qlegend2_p.h b/src/charts/legend/qlegend2_p.h
index 281e1d07..a9893a9e 100644
--- a/src/charts/legend/qlegend2_p.h
+++ b/src/charts/legend/qlegend2_p.h
@@ -61,7 +61,7 @@ public:
     QPointF offset() const;
     int roundness(qreal size);
 
-    QGraphicsItemGroup* items() { return m_items; }
+//    QQuickItemGroup* items() { return m_items; }
 
     QList<QLegendMarker*> markers(QAbstractSeries *series = 0);
     qreal maxMarkerWidth() const;
@@ -89,7 +89,7 @@ private:
     ChartPresenter2 *m_presenter;
     LegendLayout2 *m_layout;
     QChart2 *m_chart;
-    QGraphicsItemGroup *m_items;
+//    QQuickItemGroup *m_items;
     Qt::Alignment m_alignment;
     QBrush m_brush;
     QPen m_pen;
@@ -106,7 +106,7 @@ private:
     QList<QLegendMarker *> m_markers;
     QList<QAbstractSeries *> m_series;
 
-    QHash<QGraphicsItem *, QLegendMarker *> m_markerHash;
+//    QHash<QQuickItem *, QLegendMarker *> m_markerHash;
 
     friend class QLegend2;
     friend class LegendMarkerItem2;
diff --git a/src/charts/qabstractseries_p.h b/src/charts/qabstractseries_p.h
index 9f91f082..6e5ce43b 100644
--- a/src/charts/qabstractseries_p.h
+++ b/src/charts/qabstractseries_p.h
@@ -79,7 +79,7 @@ public:
     virtual void initializeAxes() = 0;
     virtual void initializeTheme(int index, ChartTheme* theme, bool forced = false) = 0;
     virtual void initializeGraphics(QGraphicsItem* parent) = 0;
-    virtual void initializeGraphics2(QGraphicsItem* parent) {}
+    virtual void initializeGraphics2(QQuickItem* parent) {}
     virtual void initializeAnimations(QChart::AnimationOptions options, int duration,
                                       QEasingCurve &curve) = 0;
 
diff --git a/src/charts/qchart2.cpp b/src/charts/qchart2.cpp
index 046668b2..f6a92db5 100644
--- a/src/charts/qchart2.cpp
+++ b/src/charts/qchart2.cpp
@@ -236,8 +236,8 @@ QT_CHARTS_BEGIN_NAMESPACE
  The properties specified by \a wFlags are passed to the QGraphicsWidget constructor.
  This constructor is called only by subclasses.
 */
-QChart2::QChart2(QChart::ChartType type, QGraphicsItem *parent, Qt::WindowFlags wFlags)
-    : QGraphicsWidget(parent, wFlags),
+QChart2::QChart2(QChart::ChartType type, QQuickItem *parent, Qt::WindowFlags wFlags)
+    : QQuickItem(parent/*, wFlags*/),
       d_ptr(new QChartPrivate2(this, type))
 {
     d_ptr->init();
@@ -247,8 +247,8 @@ QChart2::QChart2(QChart::ChartType type, QGraphicsItem *parent, Qt::WindowFlags
  Constructs a chart object that is a child of \a parent.
  The properties specified by \a wFlags are passed to the QGraphicsWidget constructor.
  */
-QChart2::QChart2(QGraphicsItem *parent, Qt::WindowFlags wFlags)
-    : QGraphicsWidget(parent, wFlags),
+QChart2::QChart2(QQuickItem *parent, Qt::WindowFlags wFlags)
+    : QQuickItem(parent/*, wFlags*/),
       d_ptr(new QChartPrivate2(this, QChart::ChartTypeCartesian))
 {
     d_ptr->init();
@@ -885,7 +885,7 @@ void QChartPrivate2::init()
 {
     m_legend = new LegendScroller2(q_ptr);
     q_ptr->setTheme(QChart::ChartThemeLight);
-    q_ptr->setLayout(m_presenter->layout());
+//    q_ptr->setLayout(m_presenter->layout());
 }
 
 void QChartPrivate2::zoomIn(qreal factor)
diff --git a/src/charts/qchart2.h b/src/charts/qchart2.h
index fec8b0aa..919e3cf8 100644
--- a/src/charts/qchart2.h
+++ b/src/charts/qchart2.h
@@ -37,6 +37,7 @@
 
 #include <private/qchart_p.h>
 #include <QChart>
+#include <QtQuick/QQuickItem>
 
 QT_BEGIN_NAMESPACE
 class QGraphicsSceneResizeEvent;
@@ -50,7 +51,7 @@ class QLegend2;
 class QChartPrivate2;
 class QBoxPlotSeries;
 
-class QT_CHARTS_EXPORT QChart2 : public QGraphicsWidget
+class QT_CHARTS_EXPORT QChart2 : public QQuickItem
 {
     Q_OBJECT
     Q_PROPERTY(QChart::ChartTheme theme READ theme WRITE setTheme)
@@ -99,7 +100,7 @@ public:
 //    Q_DECLARE_FLAGS(AnimationOptions, AnimationOption)
 
 public:
-    explicit QChart2(QGraphicsItem *parent = nullptr, Qt::WindowFlags wFlags = Qt::WindowFlags());
+    explicit QChart2(QQuickItem *parent = nullptr, Qt::WindowFlags wFlags = Qt::WindowFlags());
     ~QChart2();
 
     void addSeries(QAbstractSeries *series);
@@ -184,7 +185,7 @@ Q_SIGNALS:
     void plotAreaChanged(const QRectF &plotArea);
 
 protected:
-    explicit QChart2(QChart::ChartType type, QGraphicsItem *parent, Qt::WindowFlags wFlags);
+    explicit QChart2(QChart::ChartType type, QQuickItem *parent, Qt::WindowFlags wFlags);
     QScopedPointer<QChartPrivate2> d_ptr;
     friend class QLegend2;
     friend class DeclarativeChart;
diff --git a/src/charts/qchart3.cpp b/src/charts/qchart3.cpp
index 16363512..ee40cbd6 100644
--- a/src/charts/qchart3.cpp
+++ b/src/charts/qchart3.cpp
@@ -4,3 +4,8 @@ QChart3::QChart3()
 {
 
 }
+
+void QChart3::paint(QPainter *painter)
+{
+
+}
diff --git a/src/charts/qchart3.h b/src/charts/qchart3.h
index 3668a42d..384b32d5 100644
--- a/src/charts/qchart3.h
+++ b/src/charts/qchart3.h
@@ -2,16 +2,19 @@
 #define QCHART3_H
 
 #include <QQuickItem>
+#include <QQuickPaintedItem>
 
-class QChart3 : public QQuickItem
+class QChart3 : public QQuickPaintedItem
 {
     Q_OBJECT
 public:
     QChart3();
 
+    void paint(QPainter *painter);
 signals:
 
 public slots:
+
 };
 
-#endif // QCHART3_H
\ No newline at end of file
+#endif // QCHART3_H
diff --git a/src/charts/qpolarchart2.cpp b/src/charts/qpolarchart2.cpp
index d21e255b..dc60ddd8 100644
--- a/src/charts/qpolarchart2.cpp
+++ b/src/charts/qpolarchart2.cpp
@@ -77,7 +77,7 @@ QT_CHARTS_BEGIN_NAMESPACE
  Constructs a polar chart as a child of \a parent.
  The properties specified by \a wFlags are passed to the QChart constructor.
  */
-QPolarChart2::QPolarChart2(QGraphicsItem *parent, Qt::WindowFlags wFlags)
+QPolarChart2::QPolarChart2(QQuickItem *parent, Qt::WindowFlags wFlags)
     : QChart2(QChart::ChartTypePolar, parent, wFlags)
 {
 }
diff --git a/src/charts/qpolarchart2.h b/src/charts/qpolarchart2.h
index 2cd27b07..64d7c342 100644
--- a/src/charts/qpolarchart2.h
+++ b/src/charts/qpolarchart2.h
@@ -51,7 +51,7 @@ public:
     Q_DECLARE_FLAGS(PolarOrientations, PolarOrientation)
 
 public:
-    explicit QPolarChart2(QGraphicsItem *parent = nullptr, Qt::WindowFlags wFlags = Qt::WindowFlags());
+    explicit QPolarChart2(QQuickItem *parent = nullptr, Qt::WindowFlags wFlags = Qt::WindowFlags());
     ~QPolarChart2();
 
     void addAxis(QAbstractAxis *axis, PolarOrientation polarOrientation);
diff --git a/src/chartsqml2/chartsqml2_plugin.cpp b/src/chartsqml2/chartsqml2_plugin.cpp
index 96f7fc94..cc80b7a5 100644
--- a/src/chartsqml2/chartsqml2_plugin.cpp
+++ b/src/chartsqml2/chartsqml2_plugin.cpp
@@ -356,6 +356,7 @@ public:
                                                   QLatin1String("Trying to create uncreatable: AbstractAxis. Use specific types of axis instead."));
         qmlRegisterType<DeclarativeChart, 5>(uri, 2, 1, "ChartView");
         qmlRegisterType<DeclarativeChart2, 5>(uri, 2, 1, "ChartView2");
+        qmlRegisterType<DeclarativeChart2, 5>(uri, 2, 1, "ChartView2");
         qmlRegisterType<DeclarativeScatterSeries, 5>(uri, 2, 1, "ScatterSeries");
         qmlRegisterType<DeclarativeLineSeries, 4>(uri, 2, 1, "LineSeries");
         qmlRegisterType<DeclarativeSplineSeries, 4>(uri, 2, 1, "SplineSeries");
diff --git a/src/chartsqml2/declarativechart2.cpp b/src/chartsqml2/declarativechart2.cpp
index 37629283..7ada45b4 100644
--- a/src/chartsqml2/declarativechart2.cpp
+++ b/src/chartsqml2/declarativechart2.cpp
@@ -433,13 +433,13 @@ QT_CHARTS_BEGIN_NAMESPACE
 */
 
 DeclarativeChart2::DeclarativeChart2(QQuickItem *parent)
-    : QQuickItem(parent)
+    : QQuickPaintedItem(parent)
 {
     initChart(QChart::ChartTypeCartesian);
 }
 
 DeclarativeChart2::DeclarativeChart2(QChart::ChartType type, QQuickItem *parent)
-    : QQuickItem(parent)
+    : QQuickPaintedItem(parent)
 {
     initChart(type);
 }
@@ -480,15 +480,20 @@ void DeclarativeChart2::initChart(QChart::ChartType type)
         m_chart = new QPolarChart2();
     else
         m_chart = new QChart2();
+    m_chart->setParent(this);
+    m_chart->setSize(QSizeF(100, 100));
+//    connect(this, &QQuickItem::widthChanged, m_chart, &QQuickItem::setWidth);
+//    connect(this, &QQuickItem::widthChanged, m_chart, &DeclarativeChart2::checkWidth);
+//    connect(this, &QQuickItem::heightChanged, m_chart, &QQuickItem::setHeight);
 
     m_chart->d_ptr->m_presenter->glSetUseWidget(false);
     m_glXYDataManager = m_chart->d_ptr->m_dataset->glXYSeriesDataManager();
 
-    m_scene = new QGraphicsScene(this);
-    m_scene->addItem(m_chart);
+    m_scene = new QQuickItem(this);
+//    m_scene->addItem(m_chart);
 
     setAntialiasing(QQuickItem::antialiasing());
-    connect(m_scene, &QGraphicsScene::changed, this, &DeclarativeChart2::sceneChanged);
+//    connect(m_scene, &QGraphicsScene::changed, this, &DeclarativeChart2::sceneChanged);
     connect(this, &DeclarativeChart2::needRender, this, &DeclarativeChart2::renderScene,
             Qt::QueuedConnection);
     connect(this, SIGNAL(antialiasingChanged(bool)), this, SLOT(handleAntialiasingChanged(bool)));
@@ -500,18 +505,19 @@ void DeclarativeChart2::initChart(QChart::ChartType type)
     setAcceptHoverEvents(true);
 
     m_margins = new DeclarativeMargins(this);
-    m_margins->setTop(m_chart->margins().top());
-    m_margins->setLeft(m_chart->margins().left());
-    m_margins->setRight(m_chart->margins().right());
-    m_margins->setBottom(m_chart->margins().bottom());
-    connect(m_margins, SIGNAL(topChanged(int,int,int,int)),
-            this, SLOT(changeMargins(int,int,int,int)));
-    connect(m_margins, SIGNAL(bottomChanged(int,int,int,int)),
-            this, SLOT(changeMargins(int,int,int,int)));
-    connect(m_margins, SIGNAL(leftChanged(int,int,int,int)),
-            this, SLOT(changeMargins(int,int,int,int)));
-    connect(m_margins, SIGNAL(rightChanged(int,int,int,int)),
-            this, SLOT(changeMargins(int,int,int,int)));
+    // TODO!!
+//    m_margins->setTop(m_chart->margins().top());
+//    m_margins->setLeft(m_chart->margins().left());
+//    m_margins->setRight(m_chart->margins().right());
+//    m_margins->setBottom(m_chart->margins().bottom());
+//    connect(m_margins, SIGNAL(topChanged(int,int,int,int)),
+//            this, SLOT(changeMargins(int,int,int,int)));
+//    connect(m_margins, SIGNAL(bottomChanged(int,int,int,int)),
+//            this, SLOT(changeMargins(int,int,int,int)));
+//    connect(m_margins, SIGNAL(leftChanged(int,int,int,int)),
+//            this, SLOT(changeMargins(int,int,int,int)));
+//    connect(m_margins, SIGNAL(rightChanged(int,int,int,int)),
+//            this, SLOT(changeMargins(int,int,int,int)));
     connect(m_chart->d_ptr->m_dataset, SIGNAL(seriesAdded(QAbstractSeries*)), this, SLOT(handleSeriesAdded(QAbstractSeries*)));
     connect(m_chart->d_ptr->m_dataset, SIGNAL(seriesRemoved(QAbstractSeries*)), this, SIGNAL(seriesRemoved(QAbstractSeries*)));
     connect(m_chart, SIGNAL(plotAreaChanged(QRectF)), this, SIGNAL(plotAreaChanged(QRectF)));
@@ -700,7 +706,7 @@ void DeclarativeChart2::geometryChanged(const QRectF &newGeometry, const QRectF
 {
     if (newGeometry.isValid()) {
         if (newGeometry.width() > 0 && newGeometry.height() > 0) {
-            m_chart->resize(newGeometry.width(), newGeometry.height());
+//            m_chart->resize(newGeometry.width(), newGeometry.height());
         }
     }
     QQuickItem::geometryChanged(newGeometry, oldGeometry);
@@ -802,31 +808,32 @@ void DeclarativeChart2::sceneChanged(QList<QRectF> region)
 
 void DeclarativeChart2::renderScene()
 {
-    m_updatePending = false;
-    m_sceneImageDirty = true;
-    QSize chartSize = m_chart->size().toSize();
-    if (!m_sceneImage || chartSize != m_sceneImage->size()) {
-        delete m_sceneImage;
-        qreal dpr = window() ? window()->devicePixelRatio() : 1.0;
-        m_sceneImage = new QImage(chartSize * dpr, QImage::Format_ARGB32);
-        m_sceneImage->setDevicePixelRatio(dpr);
-        m_sceneImageNeedsClear = true;
-    }
-
-    if (m_sceneImageNeedsClear) {
-        m_sceneImage->fill(Qt::transparent);
-        // Don't clear the flag if chart background has any transparent element to it
-        if (m_chart->backgroundBrush().color().alpha() == 0xff && !m_chart->isDropShadowEnabled())
-            m_sceneImageNeedsClear = false;
-    }
-    QPainter painter(m_sceneImage);
-    if (antialiasing()) {
-        painter.setRenderHints(QPainter::Antialiasing | QPainter::TextAntialiasing
-                               | QPainter::SmoothPixmapTransform);
-    }
-    QRect renderRect(QPoint(0, 0), chartSize);
-    m_scene->render(&painter, renderRect, renderRect);
-    update();
+    // TODO
+//    m_updatePending = false;
+//    m_sceneImageDirty = true;
+//    QSize chartSize = m_chart->size().toSize();
+//    if (!m_sceneImage || chartSize != m_sceneImage->size()) {
+//        delete m_sceneImage;
+//        qreal dpr = window() ? window()->devicePixelRatio() : 1.0;
+//        m_sceneImage = new QImage(chartSize * dpr, QImage::Format_ARGB32);
+//        m_sceneImage->setDevicePixelRatio(dpr);
+//        m_sceneImageNeedsClear = true;
+//    }
+
+//    if (m_sceneImageNeedsClear) {
+//        m_sceneImage->fill(Qt::transparent);
+//        // Don't clear the flag if chart background has any transparent element to it
+//        if (m_chart->backgroundBrush().color().alpha() == 0xff && !m_chart->isDropShadowEnabled())
+//            m_sceneImageNeedsClear = false;
+//    }
+//    QPainter painter(m_sceneImage);
+//    if (antialiasing()) {
+//        painter.setRenderHints(QPainter::Antialiasing | QPainter::TextAntialiasing
+//                               | QPainter::SmoothPixmapTransform);
+//    }
+//    QRect renderRect(QPoint(0, 0), chartSize);
+//    m_scene->render(&painter, renderRect, renderRect);
+//    update();
 }
 
 void DeclarativeChart2::mousePressEvent(QMouseEvent *event)
@@ -1486,6 +1493,19 @@ void DeclarativeChart2::queueRendererMouseEvent(QMouseEvent *event)
     }
 }
 
+void DeclarativeChart2::paint(QPainter *painter)
+{
+    painter->save();
+    painter->setPen(Qt::red);
+//        painter->setPen(pen());
+//        painter->setBrush(brush());
+    QRectF rect;
+    rect.setSize(size());
+
+    painter->drawRoundedRect(rect, 0,0);//rect(), m_diameter, m_diameter);
+    painter->restore();
+}
+
 QPointF DeclarativeChart2::mapToValue(const QPointF &position, QAbstractSeries *series)
 {
     return m_chart->mapToValue(position, series);
diff --git a/src/chartsqml2/declarativechart2_p.h b/src/chartsqml2/declarativechart2_p.h
index 05716745..4228cc6f 100644
--- a/src/chartsqml2/declarativechart2_p.h
+++ b/src/chartsqml2/declarativechart2_p.h
@@ -51,6 +51,7 @@
 #include <QtCore/QLocale>
 #include <QQmlComponent>
 #include <QLegend2>
+#include <QQuickPaintedItem>
 
 QT_CHARTS_BEGIN_NAMESPACE
 
@@ -58,7 +59,7 @@ class DeclarativeMargins;
 class Domain;
 class DeclarativeAxes;
 
-class QT_QMLCHARTS_PRIVATE_EXPORT DeclarativeChart2 : public QQuickItem
+class QT_QMLCHARTS_PRIVATE_EXPORT DeclarativeChart2 : public QQuickPaintedItem
 {
     Q_OBJECT
     Q_PROPERTY(Theme theme READ theme WRITE setTheme)
@@ -237,6 +238,7 @@ private Q_SLOTS:
     void handleSeriesAdded(QAbstractSeries *series);
     void handlePendingRenderNodeMouseEventResponses();
 
+
 protected:
     explicit DeclarativeChart2(QChart::ChartType type, QQuickItem *parent);
 
@@ -251,7 +253,7 @@ private:
     // Extending QChart with DeclarativeChart is not possible because QObject does not support
     // multi inheritance, so we now have a QChart as a member instead
     QChart2 *m_chart;
-    QGraphicsScene *m_scene;
+    QQuickItem *m_scene;
     QPointF m_mousePressScenePoint;
     QPoint m_mousePressScreenPoint;
     QPointF m_lastMouseMoveScenePoint;
@@ -269,6 +271,10 @@ private:
     QVector<QMouseEvent *> m_pendingRenderNodeMouseEvents;
     QVector<MouseEventResponse> m_pendingRenderNodeMouseEventResponses;
     QRectF m_adjustedPlotArea;
+
+    // QQuickPaintedItem interface
+public:
+    void paint(QPainter *painter);
 };
 
 QT_CHARTS_END_NAMESPACE
